version: '2.2'
services:
  elastic:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.17.18
    environment:
      - discovery.type=single-node
    ulimits:
      memlock:
        soft: -1
        hard: -1
    healthcheck:
      test: curl -s http://elastic:9200 >/dev/null || exit 1
      interval: 5s
      timeout: 5s
      retries: 10
    volumes:
      - elasticdata:/usr/share/elasticsearch/data
    ports:
      - 127.0.0.1:9200:9200
    networks:
      - backend

  virtuoso:
    image: tenforce/virtuoso:virtuoso7.2.5
    environment:
      DBA_PASSWORD: ${VIRTUOSO_PASSWORD}
      SPARQL_UPDATE: "true"
    volumes:
      - virtuosodata:/database
    ports:
      - 127.0.0.1:8890:8890
    healthcheck:
      test: exit 0
      interval: 5s
      timeout: 5s
      retries: 10
    restart: always
    networks:
      - backend
    
  aims-api:
    restart: always
    depends_on:
      virtuoso:
        condition: service_healthy
      elastic:
        condition: service_healthy
    container_name: aims-api
    build: 
      context: .
      dockerfile: ./Dockerfile
    ports:
      - 127.0.0.1:5000:8080
    networks:
      - backend
    environment:
      - AIMS_SPARQL_ENDPOINT=${AIMS_SPARQL_ENDPOINT}
      - AIMS_ELASTIC_ENDPOINT=${AIMS_ELASTIC_ENDPOINT}
      - AIMS_GITLAB_URL=${AIMS_GITLAB_URL}
      - AIMS_GITLAB_PASSWORD=${AIMS_GITLAB_PASSWORD}
      - AIMS_GITLAB_GROUPID=${AIMS_GITLAB_GROUPID}

volumes:
  elasticdata:
    driver: local
  virtuosodata:
    driver: local

networks:
  backend:
    driver: bridge